// RUN: stablehlo-opt -inline %s | stablehlo-translate --interpret
// RUN: diff <(stablehlo-translate --serialize --target=current %s | stablehlo-translate --deserialize | stablehlo-opt) <(stablehlo-opt %s)

module @jit_testcase {
  func.func public @main() -> tensor<i1> {
    %0 = call @inputs() : () -> tensor<2x3xcomplex<f32>>
    %1 = call @expected() : () -> tensor<2x3xf32>
    %2 = stablehlo.imag %0 : (tensor<2x3xcomplex<f32>>) -> tensor<2x3xf32>
    %3 = stablehlo.custom_call @check.eq(%2, %1) : (tensor<2x3xf32>, tensor<2x3xf32>) -> tensor<i1>
    return %3 : tensor<i1>
  }
  func.func private @inputs() -> tensor<2x3xcomplex<f32>> {
    %0 = stablehlo.constant dense<[[(-0.474265635,1.40385771), (2.09381819,5.74420691), (2.65112162,-1.3039782)], [(3.51368785,-1.95977342), (2.76272869,2.83571172), (1.23385942,-5.07624722)]]> : tensor<2x3xcomplex<f32>>
    return %0 : tensor<2x3xcomplex<f32>>
  }
  func.func private @expected() -> tensor<2x3xf32> {
    %0 = stablehlo.constant dense<[[1.40385771, 5.74420691, -1.3039782], [-1.95977342, 2.83571172, -5.07624722]]> : tensor<2x3xf32>
    return %0 : tensor<2x3xf32>
  }
}
