// RUN: stablehlo-opt -inline %s | stablehlo-translate --interpret
// RUN: diff <(stablehlo-translate --serialize --target=current %s | stablehlo-translate --deserialize | stablehlo-opt) <(stablehlo-opt %s)

module @jit_testcase {
  func.func public @main() -> tensor<i1> {
    %0 = stablehlo.constant dense<[0, 4]> : tensor<2xi32>
    %1:2 = call @inputs() : () -> (tensor<4x2x3x5xi8>, tensor<4x3xi8>)
    %2 = call @expected() : () -> tensor<4x2x3x5xi8>
    %3 = "stablehlo.scatter"(%1#0, %0, %1#1) ({
    ^bb0(%arg0: tensor<i8>, %arg1: tensor<i8>):
      %5 = stablehlo.multiply %arg0, %arg1 : tensor<i8>
      stablehlo.return %5 : tensor<i8>
    }) {scatter_dimension_numbers = #stablehlo.scatter<update_window_dims = [0, 1], inserted_window_dims = [1, 3], scatter_dims_to_operand_dims = [1, 3]>, unique_indices = true} : (tensor<4x2x3x5xi8>, tensor<2xi32>, tensor<4x3xi8>) -> tensor<4x2x3x5xi8>
    %4 = stablehlo.custom_call @check.eq(%3, %2) : (tensor<4x2x3x5xi8>, tensor<4x2x3x5xi8>) -> tensor<i1>
    return %4 : tensor<i1>
  }
  func.func private @inputs() -> (tensor<4x2x3x5xi8>, tensor<4x3xi8>) {
    %0 = stablehlo.constant dense<"0x0001000202000202010001FFFE010400FD0400FCFF00FF0002000100FCFF040104010301FD010003F8FD060400FE03FD02FE00FF0003000002FF01050100FE02FE01FCFFFF0101060000FEFEFF00040300FA0102F901FFFF00FC0203FEFE03FD01030300FE010200FDFE00FFFE00FD05000101FE05FFFF00"> : tensor<4x2x3x5xi8>
    %1 = stablehlo.constant dense<[[4, 0, 3], [2, 0, 1], [-4, -4, 2], [6, 1, 4]]> : tensor<4x3xi8>
    return %0, %1 : tensor<4x2x3x5xi8>, tensor<4x3xi8>
  }
  func.func private @expected() -> tensor<4x2x3x5xi8> {
    %0 = stablehlo.constant dense<"0x0001000208000202010001FFFE010C00FD0400FCFF00FF0002000100FCFF040104010601FD010000F8FD060400FE03FD02FE00FF0003000002FF01050100FE020801FCFFFFFC01060000FCFEFF00040300FA0102F901FFFF00FC0203FEFE12FD01030300FE010200F4FE00FFFE00FD05000101FE05FFFF00"> : tensor<4x2x3x5xi8>
    return %0 : tensor<4x2x3x5xi8>
  }
}

